import java.io.IOException;
import java.lang.Math;

/**
 * Created by IntelliJ IDEA.
 * User: k.rafati
 * Date: Oct 31, 2003
 * Time: 9:08:43 AM
 * To change this template use Options | File Templates.
 */
public class InputFile extends FileHandler{

    public InputFile(String name){
        super(name);
        bitcount=bytecount=0;
        try{
            bytes = new byte[(int)file.length()];
            file.read(bytes);
            file.close();
        }catch(IOException e){}
    }

    public byte nextByte() throws Exception{
        if( bytecount > bytes.length)
            throw new Exception( "End of File!!");

        if( bitcount == 0)
            return bytes[bytecount++];

        byte temp = bytes[bytecount++];
        temp <<= bitcount;
        temp |= (byte)(((char)(bytes[bytecount])&255)>>>(8 - bitcount));
        return temp;
    }

    public boolean nextBit() throws Exception{
        if( bytecount >= bytes.length)
            throw new Exception( "End of File!!");

        boolean retval = ((bytes[bytecount] & (byte)Math.pow( 2, 7 - bitcount)) != 0);

        bitcount++;

        if( bitcount == 8){
            bitcount = 0;
            bytecount++;
        }

        return retval;
    }
}
