import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: k.rafati
 * Date: Oct 31, 2003
 * Time: 8:27:04 AM
 * To change this template use Options | File Templates.
 */
public class Node {
    private byte value;
    private Node left,right;

//constructor
     public Node(byte c){
        right=left=null;
        value=c;
    }

    public void dumper( OutputFile file){
        if( left == null){
            file.addBit( false);
            file.addByte( value);
            return;
        }
        //else

        file.addBit( true);
        left.dumper( file);
        right.dumper( file);
    }

    public void makeSymTab( String code, ArrayList symtab){
        if(left != null){
            left.makeSymTab( code + "0", symtab);
            right.makeSymTab( code + "1", symtab);
            return;
        }
        //else
        boolean [] madecode;

        if( code.length() == 0){
            madecode = new boolean [1];
            madecode[0] = false;
            symtab.add( new CodeTableCell( value, madecode));
        }

        //eslse
        madecode = new boolean [code.length()];

        for( int i = 0; i < code.length();i++){
            if(code.toCharArray()[i] == '1')
                madecode[i] = true;
            else
                madecode[i] = false;
        }

        symtab.add( new CodeTableCell( value, madecode));
    }

//setters & getters
    public byte getValue(){
        return value;
    }
    public Node getRight(){
        return right;
    }
    public Node getLeft(){
        return left;
    }
    public void setValue(byte val){
        value=val;
    }
    public void setRight(Node r){
        right=r;
    }
    public void setLeft(Node l){
        left=l;
    }
}
