/**
 * Created by IntelliJ IDEA.
 * User: k.rafati
 * Date: Oct 31, 2003
 * Time: 11:01:16 AM
 * To change this template use Options | File Templates.
 */
public class Unzip {
    private InputFile in;
    private OutputFile out;
    private Tree tree;

    public Unzip(String inname,String outname){
        in = new InputFile(inname);
        out = new OutputFile(outname);
    }

    public Node ReadNode(){
        try{
            Node n;
            boolean b=in.nextBit();
            if(!b)
                n = new Node(in.nextByte());
            else{
                n = new Node((byte)0);
                n.setLeft(ReadNode());
                n.setRight(ReadNode());
            }
            return n;

        }catch(Exception e){
            System.out.print(e.getMessage());
        }
        return null;
    }

    public void MakeTree(){
        tree = new Tree(ReadNode());
    }

    public void decoder(){
        Node current=tree.getRoot();
        try {
            while(true){
                if(!in.nextBit())
                    current = current.getLeft();
                else
                    current = current.getRight();
                if(current.getLeft()==null){
                    out.addByte(current.getValue());
                    current = tree.getRoot();
                }
            }
        } catch (Exception e) {
            out.close();
        }
    }

    public static void main(String [] args){
        Unzip u = new Unzip("zipped.z","out.txt");
        u.MakeTree();
        u.decoder();
    }
}
